﻿players = {
  { jump = false, run = true, left = false},
  { jump = false, run = true, left = true},
  { jump = false, run = true, left = false},
  { }
}
count = 0
function startFrameAI()
  en_x = {
    emu.read(0x0369, emu.memType.cpu),
    emu.read(0x0389, emu.memType.cpu),
    emu.read(0x03A9, emu.memType.cpu),
    emu.read(0x03C9, emu.memType.cpu),
    emu.read(0x03E9, emu.memType.cpu)
 }
  en_y = {
    emu.read(0x0368, emu.memType.cpu),
    emu.read(0x0388, emu.memType.cpu),
    emu.read(0x03A8, emu.memType.cpu),
    emu.read(0x03C8, emu.memType.cpu),
    emu.read(0x03E8, emu.memType.cpu)
  }
  en_run = { -- TODO: Bad
    emu.read(0x0363, emu.memType.cpu) < 4,
    emu.read(0x0383, emu.memType.cpu) < 4,
    emu.read(0x03A3, emu.memType.cpu) < 4,
    emu.read(0x03C3, emu.memType.cpu) < 4,
    emu.read(0x03E3, emu.memType.cpu) < 4
  }

  players[1].x = emu.read(0x0329, emu.memType.cpu)
  players[2].x = emu.read(0x0709, emu.memType.cpu)
  players[3].x = emu.read(0x0729, emu.memType.cpu)
  players[1].y = emu.read(0x0328, emu.memType.cpu)
  players[2].y = emu.read(0x0708, emu.memType.cpu)
  players[3].y = emu.read(0x0728, emu.memType.cpu)
  -- Player 1
  players[4].x = emu.read(0x0309, emu.memType.cpu)
  players[4].y = emu.read(0x0308, emu.memType.cpu)
  
  for p = 1, #players-1 do
    local x = players[p].x
    local y = players[p].y
    -- Attack enemies
    for i = 1, #en_x do
      if x + 16 > en_x[i] and x < en_x[i] + 16
        and y >= en_y[i] + 48 and y < en_y[i] + 48 + 8
        and ((en_y[i] == 0xA0 and (en_x[i] < 0x60 - 8 or en_x[i] > 256 - 0x60 + 8))  -- bottom
          --or en_y[i] == 0x78
          or (en_y[i] == 0x70 and (en_x[i] > 0x40 + 8 or en_x[i] < 256 - 0x40 - 8))  -- middle
          or (en_y[i] == 0x40 and (en_x[i] < 0x70 - 8 or en_x[i] > 256 - 0x70 + 8))) -- top
        and en_run[i] then
        players[p].jump = true
      end
    end

    local plat_y = { 0xD0, 0xA0, 0xA0, 0x78, 0x70 }
    local plat_x = { 0x80, 0x30, 0xD0, 0xE4, 0x80 }
    local plat_p = { 0.90/16, 0.80/16, 0.80/16, 0.70/16, 0.20/16 } -- probability
    if players[p].run then
      -- Jump on platforms
      for ip = 1, #plat_y do
        if players[p].left and x < plat_x[ip]     and x >= plat_x[ip] - 16
                           and y < plat_y[ip] + 8 and y >= plat_y[ip]
                           and math.random() < plat_p[ip] then
          players[p].jump = true
          break
        end
        if not players[p].left and x > 256 - plat_x[ip] and x <= 256 - plat_x[ip] + 16
                               and y < plat_y[ip] + 8   and y >= plat_y[ip]
                               and math.random() < plat_p[ip] then
          players[p].jump = true
          break
        end
      end
      -- Players collision
      for p2 = 1, #players do
        if p2 ~= p and players[p2].y == y then
          if players[p].left then
            if x - players[p2].x <  16 + 3 and x - players[p2].x > 0 
              and math.random() < 0.8 then -- Don't stuck
              players[p].left = false
              break
            end
          else
            if x - players[p2].x > -16 - 3 and x - players[p2].x < 0
              and math.random() < 0.2 then -- Don't stuck
              players[p].left = true
              break
            end
          end
        end
      end
      -- Enemies avoiding
      for e = 1, #en_x do
        if en_y[e] == y and en_run[e] then
          if players[p].left then
            if x - en_x[e] <  16 + 5 and x - en_x[e] > 0 then
              players[p].left = false
              break
            end
          else
            if x - en_x[e] > -16 - 5 and x - en_x[e] < 0 then
              players[p].left = true
              break
            end
          end
        end
      end
      if count == 60 and math.random() < 0.20 then
        players[p].left = not players[p].left
      end
    end
  end
  count = count + 1
  if count > 60 then
    count = 0
  end
end

function inputPolled()
  for p = 1, #players-1 do
    controls = {}
    if players[p].jump then
      players[p].jump = false
      controls.a = true
    end
    if players[p].run then
      if players[p].left then
        controls.left = true
      else
        controls.right = true
      end
    end
    emu.setInput(p, controls)
  end
end

math.randomseed(os.time())
for i = 1, #players-1 do
  players[i].left = math.random() < 0.5
end

emu.addEventCallback(startFrameAI, emu.eventType.startFrame)
emu.addEventCallback(inputPolled, emu.eventType.inputPolled)
emu.displayMessage("Script", "Mario Bros. 4p - AI")
